"use strict";

exports.__esModule = true;
exports.createLogger = createLogger;
function createLogger() {
    var debug = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    var _logger = {
        debug: debug
    };
    ["log", "warn", "error"].forEach(function (level) {
        _logger[level] = function () {
            if (this.debug) {
                return console[level].apply(console, Array.from(arguments));
            }
        };
    });
    return _logger;
}