'use strict';

exports.__esModule = true;
exports.compare = compare;
function compare(v1, v2) {
  v1 = v1.split('.');
  v2 = v2.split('.');
  var len = Math.max(v1.length, v2.length);

  while (v1.length < len) {
    v1.push('0');
  }
  while (v2.length < len) {
    v2.push('0');
  }

  for (var i = 0; i < len; i++) {
    var num1 = parseInt(v1[i]);
    var num2 = parseInt(v2[i]);

    if (num1 > num2) {
      return 1;
    } else if (num1 < num2) {
      return -1;
    }
  }

  return 0;
}

var init = exports.init = function init() {
  this.sys = wx.getSystemInfoSync();
};

var getSys = exports.getSys = function getSys() {
  return this.sys;
};

var getSDKversion = exports.getSDKversion = function getSDKversion() {
  return this.sys.SDKVersion;
};

var compareCurVersion = exports.compareCurVersion = function compareCurVersion(v) {
  var self = this;
  return self.compare(self.getSDKversion(), v);
};