const app = getApp();

/**
 * 请求用户权限
 *
 * @param key
 * @param notice
 */
export function requestAuth(key, notice) {
    return new Promise(function (resolve, reject) {
        if (checkHasAuth()) {
            app.globalData.globalUserInfo = wx.getStorageSync("globalUserInfo");
            app.globalUserInfo = app.globalData.globalUserInfo;
            resolve();
        }
        wx.getSetting({
            success(res) {
                if (!res.authSetting[key]) {
                    wx.authorize({
                        scope: key,
                        success() {
                            resolve();
                        },
                        fail(e) {
                            // console.log("需要给与权限");
                            wx.showModal({
                                title: notice,
                                showCancel: false,
                                success() {
                                    wx.openSetting({
                                        success: (res) => {
                                            if (!res.authSetting[key]) {
                                                reject();
                                            } else {
                                                resolve();
                                            }
                                        }
                                    })
                                }
                            });
                        }
                    })
                }
                else {
                    resolve();
                }
            },
            fail(e) {
                console.log(e);
                reject();
            }
        })
    })
}

export function checkHasAuth() {
    return !!wx.getStorageSync("globalUserInfo");
}

export function authLogin() {
    return new Promise(function (resolve, reject) {
        wx.login({
            success: function (res) {
                if (res.code) {
                    resolve(res.code)
                }
            },
            fail() {
                reject();
            }
        });
    })
}
